/*
 * Created on 1-feb-2005
 *
 */
package it.unibo.txs.app;

import it.unibo.txs.app.AppConsole;
import it.unibo.txs.prng.PrngConsole;
import it.unibo.txs.prntest.TestConsole;

import javax.swing.JFrame;
import javax.swing.JTabbedPane;
import javax.swing.JSplitPane;
/**
 * @author patrik.suzzi@gmail.com
 *
 * Primary class that represents the windows which 
 * contains the application.
 */
public class AppJFrame extends JFrame {
	
	// the controller for this JFrame
	protected AppControl appControl;
	// Some inputs
	protected AppConsole appConsole;
	protected PrngConsole prngConsole;  //  @jve:decl-index=0:visual-constraint="453,152"
	protected TestConsole testConsole;
	// App output
	protected AppTextView appTextView;
	// Test & Prng output
	protected AppTextView appTextView1;
	
	private javax.swing.JPanel jContentPane = null;

	private JTabbedPane jTabbedPane = null;
	private JSplitPane jSplitPane = null;
	/**
	 * This is the default constructor
	 */
	public AppJFrame( AppControl appControl ) {
		super();
		// sets the controller
		this.appControl = appControl;
		// components set up
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(482, 284);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
		// Window Listener Embedded here
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {
				// Pass the event to the Control
				appControl.windowClosing( e );
			}
		});
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getAppConsole(), java.awt.BorderLayout.SOUTH);
			jContentPane.add(getJTabbedPane(), java.awt.BorderLayout.WEST);
			jContentPane.add(getJSplitPane(), java.awt.BorderLayout.CENTER);
		}
		return jContentPane;
	}
	
	/**
	 * This method initializes jTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */    
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.addTab("Test", null, getTestConsole(), null);
			jTabbedPane.addTab("Prng", null, getPrngConsole(), null);
		}
		return jTabbedPane;
	}
	
	/**
	 * This metod initializes appConsole
	 * 
	 * @return AppConsole
	 */
	private AppConsole getAppConsole(){
		if(appConsole == null){
			appConsole = new AppConsole();
			// adds the appControl listener
			appConsole.addListener( appControl );
		}
		return appConsole;
	}
	
	/**
	 * This method initializes testConsole
	 * 
	 * @return TestConsole
	 */
	public TestConsole getTestConsole(){
		if(testConsole == null){
			testConsole = new TestConsole();
			// adds the appControl listener
			testConsole.addListener( appControl );
		}
		return testConsole;
	}
	
	/**
	 * This method initializes prngConsole
	 * 
	 * @return PrngConsole
	 */
	public PrngConsole getPrngConsole(){
		if(prngConsole == null){
			prngConsole = new PrngConsole();
			// adds the appControl listener
			prngConsole.addListener( appControl );
		}
		return prngConsole;
	}
	
	public AppTextView getAppTextView(){
		if(appTextView == null){
			appTextView = new AppTextView();
		}
		return appTextView;
	}
	
	public AppTextView getAppTextView1(){
		if(appTextView1 == null){
			appTextView1 = new AppTextView();
		}
		return appTextView1;
	}
	
	/**
	 * This method initializes jSplitPane	
	 * 	
	 * @return javax.swing.JSplitPane	
	 */    
	private JSplitPane getJSplitPane() {
		if (jSplitPane == null) {
			jSplitPane = new JSplitPane();
			jSplitPane.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
			jSplitPane.setTopComponent(getAppTextView());
			jSplitPane.setBottomComponent(getAppTextView1());
			jSplitPane.setDividerLocation(100);
		}
		return jSplitPane;
	}
 }  //  @jve:decl-index=0:visual-constraint="10,10"
