/*
 * Created on 1-feb-2005
 *
 */
package it.unibo.txs.app;

import it.unibo.txs.prng.PrngModel;
import it.unibo.txs.prntest.TestModel;

import java.util.Observable;

/**
 * @author patrik.suzzi@gmail.com
 *
 * This class represents the model for the main application
 */
public class AppModel extends Observable {
	
	protected TestModel testModel;
	protected PrngModel prngModel;
	
	protected byte[] sample;
	
	
	/**
	 * Creates new instance of AppModel.
	 *
	 */
	public AppModel(){
		this.testModel = new TestModel();
		this.prngModel = new PrngModel();
		this.sample = null;
	}

	/**
	 * @return Returns the sample of pseudo random bytes.
	 */
	public byte[] getSample() {
		return sample;
	}
	/**
	 * @param sample The sample of pseudo random bytes to set.
	 */
	public void setSample(byte[] sample) {
		this.setChanged();
		this.sample = sample;
		this.notifyObservers();
	}

	/**
	 * @return Returns the prngModel.
	 */
	public PrngModel getPrngModel() {
		return prngModel;
	}
	
	/**
	 * @return Returns the testModel.
	 */
	public TestModel getTestModel() {
		return testModel;
	}

}
