/*
 * Created on 1-feb-2005
 *
 */
package it.unibo.txs.prng;

import java.awt.Component;
import java.awt.event.ActionListener;

import javax.swing.JPanel;

import javax.swing.ButtonGroup;
import javax.swing.JRadioButton;
import javax.swing.BoxLayout;
/**
 * @author patrik.suzzi@gmail.com
 *
 * This class represents the prng console for selecting
 * the prng to use for generating pseudo-random bytes. 
 */
public class PrngConsole extends JPanel {

	private JRadioButton jRadioButton = null;
	private JRadioButton jRadioButton1 = null;
	private JRadioButton jRadioButton2 = null;
	private JRadioButton jRadioButton3 = null;
	
	private ButtonGroup buttonGroup;
	
	
	/**
	 * Adds a listener for this PrngConsole
	 * @param listener
	 */
	public void addListener( ActionListener listener ){
		jRadioButton.addActionListener( listener );
		jRadioButton1.addActionListener( listener );
		jRadioButton2.addActionListener( listener );
		jRadioButton3.addActionListener( listener );
	}
	
	/**
	 * This is the default constructor
	 */
	public PrngConsole() {
		super();
		initialize();
		getButtonGroup();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.setSize(119, 148);
		this.add(getJRadioButton(), null);
		this.add(getJRadioButton1(), null);
		this.add(getJRadioButton2(), null);
		this.add(getJRadioButton3(), null);
	}

	/**
	 * This method initializes jRadioButton	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getJRadioButton() {
		if (jRadioButton == null) {
			jRadioButton = new JRadioButton();
			jRadioButton.setText("BBS");
		}
		return jRadioButton;
	}
	/**
	 * This method initializes jRadioButton1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getJRadioButton1() {
		if (jRadioButton1 == null) {
			jRadioButton1 = new JRadioButton();
			jRadioButton1.setText("Random");
		}
		return jRadioButton1;
	}
	/**
	 * This method initializes jRadioButton2	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getJRadioButton2() {
		if (jRadioButton2 == null) {
			jRadioButton2 = new JRadioButton();
			jRadioButton2.setText("SecureRandom");
		}
		return jRadioButton2;
	}
	/**
	 * This method initializes jRadioButton3	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */    
	private JRadioButton getJRadioButton3() {
		if (jRadioButton3 == null) {
			jRadioButton3 = new JRadioButton();
			jRadioButton3.setText("X917");
		}
		return jRadioButton3;
	}
	
	private ButtonGroup getButtonGroup(){
		if(buttonGroup == null) {
			buttonGroup = new ButtonGroup();
			// adds the radiobuttons
			buttonGroup.add(getJRadioButton());
			buttonGroup.add(getJRadioButton1());
			buttonGroup.add(getJRadioButton2());
			buttonGroup.add(getJRadioButton3());
		}
		return buttonGroup;
	}
	
	/**
	 * initializes the PrngConsole given the PrngModel
	 * which says what prng use for generating pseudo-random
	 * bytes.
	 * @param pm the PrngModel
	 */
	public void initialize(PrngModel pm){
		Component[] components = this.getComponents();
		for( int i=0; i<components.length; i++ ){
			// foreach JRadioButton component
			if( components[i].getClass().equals(JRadioButton.class) ){
				JRadioButton rb = (JRadioButton) components[i];
				// setSelected based on it's text
				if( rb.getText().equalsIgnoreCase( pm.getPrngName() ) ){
					rb.setSelected( true );
					return;
				}
			}
		}
	}
	
}  //  @jve:decl-index=0:visual-constraint="10,10"
