/*
 * Created on 1-feb-2005
 *
 */
package it.unibo.txs.prng;

import it.unibo.txs.app.Settings;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author patrik.suzzi@gmail.com
 *
 * This class represents control for the prng.
 */
public class PrngControl implements ActionListener {
	
	protected PrngModel prngModel;
	protected PrngConsole prngConsole;
	
	public PrngControl( PrngModel prngModel, PrngConsole prngConsole){
		this.prngModel = prngModel;
		this.prngConsole = prngConsole;
		this.prngConsole.addListener( this );
		this.prngConsole.initialize( prngModel );
	}

	/**
	 * Executes the action specified by command
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent evt) {
		String cmd = evt.getActionCommand();
		if( Settings.debug ){
			System.out.println( "PrngControl <-- " + cmd );
		}
		if(	cmd.equalsIgnoreCase("bbs") ||
			cmd.equalsIgnoreCase("random") ||
			cmd.equalsIgnoreCase("securerandom") ||
			cmd.equalsIgnoreCase("x917") ){
			// selection of what PRNG to use
			prngModel.setPrngName( cmd );
		}
	}
	
	/**
	 * this method generate bytes from the selected prng.
	 *
	 */
	public byte[] generate(){
		// gets the old prn
		byte[] sample = new byte[2500];
		// generate next prn
		prngModel.getPrng().nextBytes( sample );
		// returns pseudo-random byte[]
		return sample;
	}

}
