package it.unibo.txs.prng.gens;
//package generatori;

/*
 * BBS.java
 *
 * Created on March 12, 2004, 10:27 AM
 */

/**
 *
 * @author  x0104993
 */

import it.unibo.txs.algo.Euclide;
import it.unibo.txs.algo.Primi;

import java.util.*;
import java.math.*;
import java.security.*;

public class PrngBBS extends SecureRandom {
    
    int numBit;
    private byte[] seed;
    static final int SEED_DIM = 10; //dimensione in bytes del seme
    
    /** Creates a new instance of BBS */
    public PrngBBS() {
            seed = new byte[SEED_DIM];
            java.util.Random r = new java.util.Random();
            r.nextBytes(this.seed);
        
    }
 
   
    public void setSeed(byte[] values) {
           seed = values;
    }
   
    
    public void nextBytes(byte[] risultato) {
        
        BigInteger p,q;
        BigInteger n;
        BigInteger[] x = new BigInteger[(risultato.length+1)*8];
        BigInteger s = new BigInteger(seed);
        BigInteger[] GDC = new BigInteger[3];
        int[] z = new int[risultato.length*8];
        
        
        do{
            
        p = Primi.randomPrimo(80,1e-40);
        while(!congruo(p,new BigInteger("3"),new BigInteger("4")))
          p = Primi.randomPrimo(80,1e-40);
        
      //  System.out.println("creato p.... ");
        
        q = Primi.randomPrimo(80,1e-40);
        while(!congruo(q,new BigInteger("3"),new BigInteger("4")))
          q = Primi.randomPrimo(80,1e-40);
            
        
       // System.out.println("creato q.... ");
        
        }while(p.equals(q));
        n = p.multiply(q);
        
        if((s.compareTo(new BigInteger("1")))== -1 || (s.compareTo(n.subtract(new BigInteger("1"))))== 1)
        s = randomX(n.subtract(new BigInteger("1")),n);
        
        GDC = Euclide.extendedEuclideGCD(s,n);
        while(!GDC[0].equals(new BigInteger("1")))
        {
        s = randomX(n.subtract(new BigInteger("1")),n);
        GDC = Euclide.extendedEuclideGCD(s,n); 
        }
        
        
        
            
            x[0]= s.modPow(new BigInteger("2"),n);
        for(int i=1;i<=(risultato.length*8);i++){
            x[i]= x[i-1].modPow(new BigInteger("2"),n);
            z[i-1]= x[i].mod(new BigInteger("2")).intValue();
            
            //System.out.print(" " +  z[i-1]);
        }
           /*String stringa = ("");
           for(int k=0; k<z.length/8; k++){
                for(int w=0; w<8; w++){
                    stringa = (stringa+z[w]);
                    System.out.println(stringa);
                }
                int num = Integer.parseInt(stringa,2);
                System.out.print(num);
                risultato[k] = (byte)num;
                //System.out.print(" " +  risultato[k]);
            }*/
        
            int zLen = z.length;
            int nBytes = zLen/8;
            for (int j=0; j<nBytes ;j++){//ogni otto int 
                byte val = 0;
                 for(int i=0; i<8; i++){
                 val |= (byte)(z[j+i]<<i);
                 
            }
           //mettiNellArray(val) un byte
                risultato[j] = val;
               // System.out.print(" "+ val);
        }
            
            
            
            
    }
    
    
    /** Funzione che calcola "  a congruo b modulo n "
     * @param a   BigInteger
     * @param b   BigInteger
     * @param n   BigInteger
     *
     * @return true nel caso a sia congruo b  modulo n
     **/
    public static boolean congruo(BigInteger a, BigInteger b, BigInteger n)
    {
        return ((a.mod(n).equals(b)));
    }
    
    public static BigInteger randomX(BigInteger max, BigInteger n){
       
        Random w = new Random();
        byte[] val = new byte[8];
        BigInteger t;
        do{
        w.nextBytes(val);
        t = new BigInteger(val);
        }while((t.compareTo(new BigInteger("1")))== -1 || (t.compareTo(n.subtract(new BigInteger("1"))))== 1);
      
        return t;
        }
    
    
     //TEST di PROVA
	/* public static void main (String[] args){
             System.out.println("Inizio.... ");
             byte[] NumBytes = new byte[4];
             BBS bbs = new BBS();
             bbs.nextBytes(NumBytes);
             
             
               
         }*/
    
    
    
    
    
    
}
