/*
 * GenericGen.java
 *
 * Created on 2 marzo 2004, 12.30
 */

package it.unibo.txs.prng.gens;

import java.security.SecureRandom;

/** Classe generica che fa da PRNG. NON  UN VERO SECURE_RANDOM, per mostra
 * bene di cosa serve ad una classe per estendere SecureRandom.
 *
 * @author  x9000340
 */
public class PrngSecureRandom extends SecureRandom{
  
  byte[] seed = {
    (byte) 0xaa, (byte) 0xfd, (byte) 0x12, (byte) 0xf6, (byte) 0x59,
    (byte) 0xca, (byte) 0xe6, (byte) 0x34, (byte) 0x89, (byte) 0xb4,
    (byte) 0x79, (byte) 0xe5, (byte) 0x07, (byte) 0x6d, (byte) 0xde,
    (byte) 0xc2, (byte) 0xf0, (byte) 0x6c, (byte) 0xb5, (byte) 0x8f
    };

  /** <ENG>Fill the byte[] array of pseudo random values</ENG>
   * <ITA>Riempie l'array byte[] con valori pseudo casuali</ITA>
   *
   * @param  bytes: array 
   */
  public void nextBytes(byte[] bytes) {
    int offset = 0;

    while ((offset + seed.length) < bytes.length) {
      System.arraycopy(seed, 0, bytes, offset, seed.length);

      offset += seed.length;
    }

    System.arraycopy(seed, 0, bytes, offset, bytes.length - offset);
  }
  
}
