/*
 * Created on 1-feb-2005
 *
 */
package it.unibo.txs.prntest;

import java.awt.Component;
import java.awt.event.ActionListener;
import javax.swing.JPanel;

import javax.swing.JCheckBox;
import javax.swing.BoxLayout;
/**
 * @author patrik.suzzi@gmail.com
 *
 * This class represents the console for selecting tests
 * to do on sample containing pseudo random bytes. 
 */
public class TestConsole extends JPanel {

	private JCheckBox jCheckBox = null;
	private JCheckBox jCheckBox1 = null;
	private JCheckBox jCheckBox2 = null;
	private JCheckBox jCheckBox3 = null;
	
	/**
	 * Adds a listener to this TestConsole
	 * @param listener
	 */
	public void addListener( ActionListener listener ){
		jCheckBox.addActionListener( listener );
		jCheckBox1.addActionListener( listener );
		jCheckBox2.addActionListener( listener );
		jCheckBox3.addActionListener( listener );
	}
	
	/**
	 * This is the default constructor
	 */
	public TestConsole() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.setSize(95, 115);
		this.add(getJCheckBox(), null);
		this.add(getJCheckBox1(), null);
		this.add(getJCheckBox2(), null);
		this.add(getJCheckBox3(), null);
	}

	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBox() {
		if (jCheckBox == null) {
			jCheckBox = new JCheckBox();
			jCheckBox.setText("LongRun");
		}
		return jCheckBox;
	}
	/**
	 * This method initializes jCheckBox1	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBox1() {
		if (jCheckBox1 == null) {
			jCheckBox1 = new JCheckBox();
			jCheckBox1.setText("Monobit");
		}
		return jCheckBox1;
	}
	/**
	 * This method initializes jCheckBox2	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBox2() {
		if (jCheckBox2 == null) {
			jCheckBox2 = new JCheckBox();
			jCheckBox2.setText("Poker");
		}
		return jCheckBox2;
	}
	/**
	 * This method initializes jCheckBox3	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getJCheckBox3() {
		if (jCheckBox3 == null) {
			jCheckBox3 = new JCheckBox();
			jCheckBox3.setText("Runs");
		}
		return jCheckBox3;
	}

	/**
	 * This methods initialize TestConsole with the specified
	 * TestModel values of selectedTests
	 * @param tm the TestModel
	 */
	public void initialize(TestModel tm) {
		Component[] components = this.getComponents();
		for( int i=0; i<components.length; i++ ){
			// foreach JCheckBox component
			if( components[i].getClass().equals(JCheckBox.class) ){
				JCheckBox cb = (JCheckBox) components[i];
				// setSelected based on it's text
				cb.setSelected( tm.isTestSelected( cb.getText() ) );
				
			}
		}
		
	}
       }  //  @jve:decl-index=0:visual-constraint="10,10"
