/*
 * LongRun.java
 *
 * Created on 25 febbraio 2004, 11.29
 */

package it.unibo.txs.prntest.tests;

/**
 *
 * @author  x9000340
 */
public class LongRunTest extends PrngTest {

	private int maxRun;

	private int sumOccurr;

	private boolean longRun;

	/** Creates a new instance of LongRun */
	public LongRunTest() {
		result = "LongRun Test: ";
		maxRun = 0;
		sumOccurr = 0;
		longRun = false;
	}

	/** Gets a bit from an array of bytes, the bit position is specified with
	 * the integer i.
	 * @param the integer that specify the desired bit position
	 */
	private boolean getBit(int i) {
		// j=i/8 (integer division) et k=i%8 (module)
		// => i = (j*8)+k
		return (((byte) 1) == ((this.sample[(i / 8)] >> (i % 8)) & (byte) 1));
	}

	/** Executes the test and store the results internal at the classes.
	 * after this test it's possible to observe the values of zero or one Runs
	 * arraya, that misure occurrencies of runs, and it's possible to obtain a 
	 * string representation for the actual status of the test
	 */
	public void run() {
		maxRun = 0;
		longRun = false;

		if (!sampleSetOk) //sample bytes not set
			return;

		boolean cur, last;
		int nOccurr = 1;
		cur = last = getBit(0);

		for (int i = 1; i < 20000; i++) {
			cur = getBit(i);
			if (cur == last)
				nOccurr++;
			else {
				if (nOccurr > maxRun)
					maxRun = nOccurr;
				sumOccurr += nOccurr; //DEBUG
				nOccurr = 1;
			}
			last = cur;
		}
		//last iteration
		if (nOccurr > maxRun)
			maxRun = nOccurr;
		sumOccurr += nOccurr; //DEBUG

		testPassed = (maxRun < 34);
	}

	/** Report evolution of the operation with the monobit test.
	 * @return string representation for the actual Monobit Test status.
	 *
	 */
	public String getResult() {
		String s = "\t";

		String postFix = "";

		if (sampleSetOk) {
			s += " test " + ((testPassed) ? " Passed. " : " NOT Passed. ");
			s += "\t";
			postFix = "( sumOccurr. : " + sumOccurr + ", maxRun: " + maxRun
					+ " )";
		} else
			postFix = " sample NOT set. ";

		return result + s + postFix;
	}
}