/*
 * MonobitTest.java
 *
 * Created on 24 febbraio 2004, 11.46
 */

package it.unibo.txs.prntest.tests;

/**
 *
 * @author  x9000340
 */
public class MonobitTest extends PrngTest {
	
	// private data, accessibile via getter properties
	private int ones;
	
	private int zeros;
	
	/** Creates a new instance of MonobitTest */
	public MonobitTest() {
		result = "Monobit Test: ";
	}
	
	/** Executes the test and store the results internal at the classes.
	 * after this test it's possible to observe the values of zeros or ones
	 * properties, and it's possible to obtain a string representation for
	 * the actual status of the test
	 */
	public void run() {
		ones = 0;
		zeros = 0;
		if (!sampleSetOk) //sample bytes not set
			return;
		for (int i = 0; i < sample.length; i++) {
			byte temp = sample[i];
			for (int j = 0; j <= 7; j++) {
				if ((temp & (byte) 1) == 1)
					ones++;
				else
					zeros++;
				temp = (byte) (temp >> 1);
			}
		}
		if (9654 < ones && ones < 10346)
			testPassed = true;
	}
	
	/** Report evolution of the operation with the monobit test.
	 * @return string representation for the actual Monobit Test status.
	 *
	 */
	public String getResult() {
		String s = "\t";

		String postFix = "";

		if (sampleSetOk) {
			s += " test " + ((testPassed) ? " Passed. " : " NOT Passed. ");
			s += "\t";
			postFix = "( ones:" + ones + ", zeros: " + zeros
			+ " )";
		} else
			postFix = " sample NOT set. ";

		return result + s + postFix;
	}
	
	/** After doTest() report number of "1" occurrencies.
	 * @return number of ones recognized in the Monobit test.
	 *
	 */
	public int getOnes() {
		return ones;
	}
	
	/** After doTest() report number of "0" occurrencies.
	 * @return number of zeros recognized in the Monobit test.
	 *
	 */
	public int getZeros() {
		return zeros;
	}
	
}