/*
 * PrngTest.java
 *
 * Created on 24 febbraio 2004, 11.36
 */

package it.unibo.txs.prntest.tests;

/**
 *
 * @author  x9000340
 */
public abstract class PrngTest implements Runnable{
  
  protected byte[] sample = null;
  protected String result = null;
  protected boolean testPassed = false;
  protected boolean sampleSetOk = false;
  
  /** Creates a new instance of PrngTest */
  public PrngTest() {
    this.sample = new byte[2500];
    // Here starts other test constructors
  }
  
  /** executes the test and store the results in the concrete class */
  public abstract void run();
  
  /** result of the test as a string */
  public abstract String getResult();
  
  /** Insert an array of bytes as a sample to examine with doTest() Method
   * If the sample is set right an internal property (SampleSetOk) goes true
   * @param the byte[] that contain the sample (at least 2500*8 bits)
   */
  public void setSample(byte[] bytes) {
  	// Exc
    if ( bytes!=null && bytes.length >= sample.length ){
     for (int i=0; i<sample.length; i++){
       sample[i] = bytes[i];
     }
     sampleSetOk = true;
    }
//    else throw ...
  }
   
  /** Says if the specified test was Passed.
   * @return true if test was passed.
   */
  public boolean isTestPassed() {
    return testPassed;
  }  
  
  /** Says if the sample of random bits is set.
   * @return true if the sample is set.
   */
  public boolean isSampleSetOk() {
    return sampleSetOk;
  }
  
}
