/*
 * Created on 26-gen-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package it.unibo.txs.util;

import java.awt.Component;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Reader;
import java.io.StringReader;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 * @author patrik.suzzi@gmail.com
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DialogUtil {
	
	/**
	 * Shows a loadfile dialog then returns the specified file, 
	 * if selected. else return null.
	 * @param parent the parent component of the dialog.
	 * @return the file, if selected.
	 */
	public static byte[] loadFileBytes( Component parent ){
		JFileChooser fc = new JFileChooser();
		byte[] bytes = new byte[2500];
		File file = null;
		int returnVal = fc.showOpenDialog(parent);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            file = fc.getSelectedFile();
        }
        else
        	return null;
        FileInputStream is;
        int available;
        try {
			is = new FileInputStream( file );
			// check file dimensions > 2500
			available = is.available();
			if( available < 2500 ){
				showWarnMsg( parent, "file seems shorter than 2500 bytes, please retry " );
				return null;
			}
			if( available > 2500 ){
				showInfoMsg( parent, "file seems longer than 2500 bytes; will be truncated"  );
			}
			// reads bytes
			is.read( bytes );
			is.close();
		} catch (FileNotFoundException e) {
			// TODO Stream Error: opening
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Stream Error: checking, reading or closing
			e.printStackTrace();
		}
		return bytes;
	}
	
	/**
	 * Shows a saveFileDialog and try to save the passed
	 * byte[] argument as the file content
	 * 
	 * @param bytes the byte[] to save 
	 * @param parent the parent component for the dialog
	 * 
	 */
	public static void saveFileBytes( byte[] bytes, Component parent ){
		if( bytes == null )
			showWarnMsg( parent, "Error saving a null byte[]" );
		// File selection
		JFileChooser fc = new JFileChooser();
		int returnVal = fc.showSaveDialog(parent);
		File file = null;
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            file = fc.getSelectedFile();
        }
        else
        	return;
        // Stream Opening, Writing and Closing
        FileOutputStream os;
		try {
			os = new FileOutputStream( file );
			os.write( bytes );
			os.close();			
		} catch (FileNotFoundException e) {
			// TODO Stream Error: opening
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Stream Error: writing or closing
			e.printStackTrace();
		}
	}
	
	
	
	
	/**
	 * Open a dialog for obtaining a filename. The type of dialog is 
	 * specified by the String parameter called mode. If mode equals 
	 * "Save" the dialog is a SaveFileDialog, else is an OpenFileDialog
	 * 
	 * <em>this metod ought be moved in an external class because
	 * will be useful for multiple classes of the framework</em>
	 *  
	 * @param mode
	 * @return
	 */
	public static String getFileName(Component parent, String mode){
		JFileChooser fc = new JFileChooser();
		File file = null;
		int returnVal;
		// Finestra Modale risp. la finestra principale !
		if (mode.equals("Save"))
			returnVal = fc.showSaveDialog(parent);
		else
			returnVal = fc.showOpenDialog(parent);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            file = fc.getSelectedFile();
            //This is where a real application would open the file.
            System.out.println("Opening: " + file.getName() + ".");
        } else {
        	System.out.println("Open command cancelled by user.");
        }
        
        return file.getAbsolutePath(); 
	}
	/**
	 * Opens the File specified by the filepath, then try to return
	 * a string representation of the file content. If the file it's
	 * a text file this method will return the textual content.
	 * 
	 * <em>this metod ought be moved in an external class because
	 * will be useful for multiple classes of the framework</em>
	 * 
	 * @param filePath the path for the File
	 * @return the String representation 
	 */
	public static String loadFileContent(String filePath){
		Reader reader = null;
		File srcFile = new File(filePath);
		
		if(srcFile==null)
			return "No File Selected";
			
		try {
			reader = new BufferedReader(new FileReader(srcFile));
		} catch (FileNotFoundException e) {
			System.out.println("user.dir: " + System.getProperty("user.dir: ") );
			System.out.println("File " + srcFile.getPath() + " Non Trovato !!!");
			e.printStackTrace();
		}
		StringBuffer src = new StringBuffer();
		// sezione che piglia 
		int c; 					// get the first char
		try {
			c = reader.read();
			src = new StringBuffer();
			// lettura del prossimo carattere
			while ( c != -1 ) {
				//	appendo i caratteri in coda. 
				src.append((char)c);
				c = reader.read();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		// .. e finalmente ottengo il testo
		return src.toString();
	}
	/**
	 * Save the textual content in the file specified by the fileName
	 * String. Returns a String representing the status of the work.
	 * 
	 * <em>this metod ought be moved in an external class because
	 * will be useful for multiple classes of the framework</em>
	 * 
	 * @param fileName the name of the File
	 * @param fileContent the content of the File
	 * @return status representation
	 */
	public static String saveFileContent(String fileName, String fileContent){
		StringReader src = new StringReader(fileContent);
		FileWriter out = null;
		try {
			out = new FileWriter(fileName);
			int c;
			while( (c=src.read()) != -1)
				out.write(c);
			out.close();
			return "file saved";
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "file not saved";
		}
	}
	/**
	 * Shows a dialog for an Information Message
	 * @param msg the message to show
	 */
	public static void showInfoMsg(Component parent, String msg){
		JOptionPane.showMessageDialog(parent,
			    msg + ".",
			    "Information ",
			    JOptionPane.INFORMATION_MESSAGE);
	}
	/**
	 * Shows a dialog for a Warning Message
	 * @param msg the warning to show
	 */
	public static void showWarnMsg(Component parent, String msg){
		JOptionPane.showMessageDialog(parent,
			    msg + ".",
			    "Warning ",
			    JOptionPane.WARNING_MESSAGE);
	}
	/**
	 * Shows a dialog for an Error Message
	 * @param msg the error to show
	 */
	public static void showErrorMsg(Component parent, String msg){
		JOptionPane.showMessageDialog(parent,
			    msg + ".",
			    "Error ",
			    JOptionPane.ERROR_MESSAGE);
	}
	/**
	 * Shows a dialog message that prompt a specified message
	 * and try to retrieve a String information from the user.
	 * @param request the message to prompt
	 * @return the String retrieved
	 */
	public static String getString(Component parent, String request){
		Object[] possibilities = null; // Simple String instead JCombo 
		String s = (String)JOptionPane.showInputDialog(
		                    parent,
		                    request,
		                    "Property Insert",
		                    JOptionPane.PLAIN_MESSAGE,
		                    null,
		                    possibilities,
		                    "<property-value>");
		
		if ((s != null) && (s.length() > 0))
			return s;
		return "";
	}

}
